/// <reference path="../includes/jquery.d.ts" />
/// <reference path="../includes/require.d.ts" />
var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", 'boardgame'], function(require, exports, __BoardGame__) {
    var BoardGame = __BoardGame__;

    /* Tic Tac Toe */
    var TicTacToe = (function (_super) {
        __extends(TicTacToe, _super);
        function TicTacToe(element) {
            var _this = this;
            _super.call(this, new TicTacToeBoard(this), element);

            /* Style the board */
            this.$.addClass("TicTacToeBoard");

            this.on("player:ready", function () {
                console.log("player is ready");
            });

            /* Cycle player turns when players take a turn */
            this.on("player:placed", function () {
                _this.CyclePlayers();
            });

            this.on("player:placed", function (event, move) {
                var winner = _this.WhoWins(move);
                if (winner !== undefined)
                    _this.fire("player:win", winner);
            });

            /* Ensure correct board size */
            $(window).on('resize', function () {
                _this.OnResize();
            });
            this.OnResize();
        }
        TicTacToe.prototype.OnResize = function () {
            this.$.width(this.$.height());
        };

        TicTacToe.prototype.WhoWins = function (move) {
            var position = this.Board.GetPlaceIndex(move.to) - 1;
            var playerspiece = move.to.Holds;

            if (this.CheckPeiceAt(playerspiece, position - 6) + this.CheckPeiceAt(playerspiece, position - 3) + this.CheckPeiceAt(playerspiece, position) + this.CheckPeiceAt(playerspiece, position + 3) + this.CheckPeiceAt(playerspiece, position + 6) >= 3)
                return move.player;

            if (this.CheckPeiceAt(playerspiece, position - 2) + this.CheckPeiceAt(playerspiece, position - 1) + this.CheckPeiceAt(playerspiece, position) + this.CheckPeiceAt(playerspiece, position + 1) + this.CheckPeiceAt(playerspiece, position + 2) >= 3)
                return move.player;

            if (this.CheckPeiceAt(playerspiece, 0) + this.CheckPeiceAt(playerspiece, 4) + this.CheckPeiceAt(playerspiece, 8) == 3)
                return move.player;

            if (this.CheckPeiceAt(playerspiece, 2) + this.CheckPeiceAt(playerspiece, 4) + this.CheckPeiceAt(playerspiece, 6) == 3)
                return move.player;

            return undefined;
        };

        TicTacToe.prototype.CheckPeiceAt = function (piece, position) {
            var check = this.Board.Places[position];
            if (check === undefined || check.Holds === undefined)
                return 0;

            if (check.Holds.Type == piece.Type)
                return 1;
            return 0;
        };
        return TicTacToe;
    })(BoardGame.Game);

    var TicTacToeBoard = (function (_super) {
        __extends(TicTacToeBoard, _super);
        function TicTacToeBoard(game) {
            _super.call(this, game);
            this.style("TicTacToeBoard");
        }
        TicTacToeBoard.prototype.AddPlaces = function () {
            for (var i = 0; i < 9; i++) {
                this.AddPlace(new TicTacToePlace(this));
            }
        };
        return TicTacToeBoard;
    })(BoardGame.GameBoard);

    var TicTacToePlace = (function (_super) {
        __extends(TicTacToePlace, _super);
        function TicTacToePlace(board) {
            var _this = this;
            _super.call(this, board);
            this.style("TicTacToePlace").click(function () {
                _this.Board.Game.TakeTurn(_this);
            });
        }
        return TicTacToePlace;
    })(BoardGame.BoardPlace);

    var TicTacToePlayer = (function (_super) {
        __extends(TicTacToePlayer, _super);
        function TicTacToePlayer(name, board) {
            _super.call(this, "", board);
            this.ready(true);
            this.PlayerType = name;
        }
        TicTacToePlayer.prototype.TakeTurn = function (place) {
            this.Place((new GamePieces[this.PlayerType]()), place);
        };

        TicTacToePlayer.prototype.IconSrc = function () {
            if (this.PlayerType == "Naught")
                return "../img/o.png";
else if (this.PlayerType == "Cross")
                return "../img/x.png";
        };

        TicTacToePlayer.prototype.Color = function () {
            if (this.PlayerType == "Naught")
                return "rgb(185,74,72)";
else if (this.PlayerType == "Cross")
                return "rgb(58,135,173)";
        };
        return TicTacToePlayer;
    })(BoardGame.Player);
    exports.TicTacToePlayer = TicTacToePlayer;

    var GamePieces;
    (function (GamePieces) {
        var Naught = (function (_super) {
            __extends(Naught, _super);
            function Naught() {
                _super.call(this, "Naught");
                this.$.append($(document.createElement("img")).attr("src", "../img/o.png").css({ "width": "100%", "height": "100%", "padding": "10px" }));
                this.$.css({
                    "width": "100%",
                    "height": "100%",
                    "margin": "0px !important",
                    "padding": "10% !important",
                    "background-color": "rgb(185,74,72)"
                });
            }
            return Naught;
        })(BoardGame.GamePiece);
        GamePieces.Naught = Naught;

        var Cross = (function (_super) {
            __extends(Cross, _super);
            function Cross() {
                _super.call(this, "Cross");
                this.$.append($(document.createElement("img")).attr("src", "../img/x.png").css({ "width": "100%", "height": "100%", "padding": "10px" }));
                this.$.css({
                    "width": "100%",
                    "height": "100%",
                    "margin": "0px !important",
                    "padding": "10% !important",
                    "background-color": "rgb(58,135,173)"
                });
            }
            return Cross;
        })(BoardGame.GamePiece);
        GamePieces.Cross = Cross;
    })(GamePieces || (GamePieces = {}));

    var ttt;
    (function (Controller) {
        function NewGame() {
            $("#NewGamePanel").show();
            $("#GameBoard").hide();
            $("#AboutPanel").hide();
            // if (ttt.started==true)
        }
        Controller.NewGame = NewGame;

        function ShowAbout() {
            $("#NewGamePanel").hide();
            $("#GameBoard").hide();
            $("#AboutPanel").show();
        }
        Controller.ShowAbout = ShowAbout;
        function ShowGame() {
            $("#NewGamePanel").hide();
            $("#GameBoard").show();

            $("#AboutPanel").hide();
        }
        Controller.ShowGame = ShowGame;
        function CreateNewGame() {
            ShowGame();
            $("#GameBoard").empty();

            ttt = undefined;
            ttt = ttt = new TicTacToe($("#GameBoard"));

            var Naught = new TicTacToePlayer("Naught", ttt.Board);
            Naught.Name = $("#Player1Name").val() != "" ? $("#Player1Name").val() : "Player 1";
            var Cross = new TicTacToePlayer("Cross", ttt.Board);
            Cross.Name = $("#Player2Name").val() != "" ? $("#Player2Name").val() : "Player 2";
            ttt.AddPlayer(Naught);
            ttt.AddPlayer(Cross);

            $("#NavResumeGame small").text(ttt.Players[0].Name + " vs " + ttt.Players[1].Name);
            $("#DetailsText").hide();
            $("#NavResumeGame").show();
            $(".nav button.active").removeClass("active");
            $("#NavResumeGame").addClass("active");

            ttt.on("player:yourturn", TurnChanged);
            ttt.on("player:win", PlayerWin);
            $('#WinModal').on('hide.bs.modal', function () {
                $("#TurnInfo").hide();
                $("#NavResumeGame").hide();
                $("#NavNewGame").addClass("active");
                NewGame();
            });
            TurnChanged(undefined, ttt.CurrentPlayer());
        }
        Controller.CreateNewGame = CreateNewGame;

        /* What to do when the player whos turn it is has changed */
        function TurnChanged(event, player) {
            $("#TurnInfo").show();
            $("#TurnInfo #TurnPlayerText").text(player.Name + "'s turn.");
            $("#TurnInfo #TurnPlayerImage").attr("src", player.IconSrc()).css("background-color", player.Color());
        }
        Controller.TurnChanged = TurnChanged;

        function PlayerWin(event, player) {
            ttt.Started = false;

            ($('#WinModal')).modal("show");

            $('#WinText').empty();

            $('#WinText').append($(document.createElement("span")).text(player.Name + " has won."));
        }
        Controller.PlayerWin = PlayerWin;
    })(exports.Controller || (exports.Controller = {}));
    var Controller = exports.Controller;

    $(function () {
        /* Show initial start field */
        Controller.NewGame();
        $("#TurnInfo").hide();

        /* Navigation Pressed */
        $(".nav button").click(function () {
            $(".nav button.active").removeClass("active");
        });

        /* Resume Button */
        $("#NavResumeGame").hide();
        $("#NavResumeGame").click(function () {
            Controller.ShowGame();
            $("#NavResumeGame").addClass("active");
        });

        $("#NavNewGame").click(function () {
            $("#NavNewGame").addClass("active");
            Controller.NewGame();
        });

        $("#StartGameButton").click(function () {
            Controller.CreateNewGame();
        });

        $("#NavAbout").click(function () {
            $("#NavAbout").addClass("active");
            Controller.ShowAbout();
        });
    });
});
